

#property indicator_chart_window

extern string Range = "========= Time =========";
extern int    NumberOfDays = 100; 
extern string Begin     = "00:00";   
extern string End       = "23:59";
extern int CountDays     =50;

double close[];

int shift;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
void init()
 {
  SetIndexBuffer(0,close);     
}

//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
void deinit()
 {
  int ObjectCount = ObjectsTotal();
   for (int i=ObjectCount-1; i>=0; i--)
   {
      if(StringFind(ObjectName(i),"Ma") != -1)
      {
         ObjectDelete(ObjectName(i));
      }  
   }
//----
   return(0);

}

void start() 
{

         //...........................................
  datetime dt=CurTime();
  

  for (int i=0; i<NumberOfDays; i++)

     {
    DrawObjects(dt, "Ma"+i, Begin, End);
    dt=decDateTradeDay(dt);
    while (TimeDayOfWeek(dt)>5) dt=decDateTradeDay(dt);
  }
     
}

//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
void DrawObjects(datetime dt, string no, string tb, string te)

 {
  datetime t1, t2;
  double   p3,A,B;
  int      b1, b2;
     double  Angle=0; 
          
   //...........................................................
  t1=StrToTime(TimeToStr(dt, TIME_DATE)+" "+tb);
  t2=StrToTime(TimeToStr(dt, TIME_DATE)+" "+te);
  b1=iBarShift(NULL, 0, t1);
  b2=iBarShift(NULL, 0, t2);
p3=Open[b1]; //00:00

      for (shift=0;shift<=CountDays;shift++)
      {
       close[shift] = iOpen(NULL,PERIOD_D1,shift)*100000;        
      }

      for (shift=0;shift<=CountDays-1;shift++)
      {
        
 
       Angle = MathSqrt(close[shift]);

      A=p3;     

}

//----------------------------------------------------------------------------

   ObjectCreate(no+"Open Line["+shift+"]",OBJ_TREND,0,0,0,0);
  
          ObjectSet(no+"Open Line["+shift+"]",OBJPROP_RAY,false);
          ObjectSet(no+"Open Line["+shift+"]",OBJPROP_WIDTH,3);
          ObjectSet(no+"Open Line["+shift+"]",OBJPROP_COLOR,White);
          ObjectSet(no+"Open Line["+shift+"]",OBJPROP_PRICE1,A);
          ObjectSet(no+"Open Line["+shift+"]",OBJPROP_PRICE2,A );
          ObjectSet(no+"Open Line["+shift+"]",OBJPROP_TIME1,t1);
          ObjectSet(no+"Open Line["+shift+"]",OBJPROP_TIME2,t2);

//----------------------------------------------------------------------------

         ObjectCreate(no+"Int label", OBJ_TEXT, 0, 0,0);
         ObjectSetText(no+"Int label", "                     Angle= "+DoubleToStr(Angle,0), 12, "Tahoma");
         ObjectSet(no+"Int label",OBJPROP_COLOR,White);
         ObjectSet(no+"Int label",OBJPROP_PRICE1,A);
         ObjectSet(no+"Int label",OBJPROP_TIME1,t1);

}

//----
   return(0);


datetime decDateTradeDay (datetime dt)
 {
  int ty=TimeYear(dt);
  int tm=TimeMonth(dt);
  int td=TimeDay(dt);
  int th=TimeHour(dt);
  int ti=TimeMinute(dt);

  td--;
  if (td==0)
   {
    tm--;
    if (tm==0)
     {
      ty--;
      tm=12;
    }
    if (tm==1 || tm==3 || tm==5 || tm==7 || tm==8 || tm==10 || tm==12) td=31;
    if (tm==2) if (MathMod(ty, 4)==0) td=29; else td=28;
    if (tm==4 || tm==6 || tm==9 || tm==11) td=30;
  }
  return(StrToTime(ty+"."+tm+"."+td+" "+th+":"+ti));
}

